#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <pthread.h>

#define BUF_SIZE 1024


int serv_sock, clnt_sock, lcd_sock;
int is_car;

void error_handling(char *message){
    fputs(message,stderr);
    fputc('\n',stderr);
    exit(1);
}

void *wait_client(void* data){
	char* port = (char*)data;
	clnt_sock = -1;
    struct sockaddr_in serv_addr;

    serv_sock = socket(PF_INET, SOCK_STREAM, 0);
    if (serv_sock == -1)
        error_handling("socket() error");

    memset(&serv_addr, 0, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port = htons(atoi(port));

    if (bind(serv_sock, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) == -1)
        error_handling("bind() error");

	int clnt_addr;
    socklen_t clnt_addr_size;

    printf("[*] wait for client ...\n");

    if (listen(serv_sock, 5) == -1)
        error_handling("listen() error");

    if (clnt_sock < 0) {
        clnt_addr_size = sizeof(clnt_addr);
        clnt_sock = accept(serv_sock, (struct sockaddr*)&clnt_addr, &clnt_addr_size);
        if (clnt_sock == -1)
            error_handling("accept() error");
        else
            printf("[*] client connected\n");
    }
}

void *connect_server(void * data){
	char* addr = ((char**)data)[0];
	char* port = ((char**)data)[1];
	struct sockaddr_in serv_addr;

    lcd_sock = socket(PF_INET, SOCK_STREAM, 0);
    if (lcd_sock == -1)
        error_handling("socket() error");

    memset(&serv_addr, 0, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = inet_addr(addr);
    serv_addr.sin_port = htons(atoi(port));

    printf("%s  %s\n", addr, port);

    if (connect(lcd_sock, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) == -1)
        error_handling("connect() error");
    else
        printf("server connect \n");

}

void *read_person(){
    char buf[2];
    while(1){
        if(read(clnt_sock, buf, sizeof(buf)) > 0){
            system("raspistill -o /home/uisoo/Desktop/project/Res/input.JPG.jpg");
            system("/home/uisoo/Desktop/opencv");
            FILE* fp;
            fp = fopen("/home/uisoo/Desktop/project/output.JPG", "r");
            char *tmp;
            fread(tmp, sizeof(char), 1024, fp);
            fclose(fp);
            printf("%s\n", buf);
            if(strcmp(buf, "1") == 0){
                is_car = 1;
                write(lcd_sock, tmp, sizeof(tmp));
            }else{
                write(lcd_sock, "empty", sizeof(tmp));
            }
        }
    }
}

int main(int argc, char* argv[]) {

    if (argc != 4) {
        printf("Usage : %s <sensor port>, <ip> <port> \n", argv[0]);
    }

	// Wait Client (Sensor)
	pthread_t wait_client_t, connect_lcd_t;
	int status;

	if(pthread_create(&wait_client_t, NULL, wait_client, (void*)argv[1]) < 0){
		perror("thread create error: ");
		exit(0);
    }

	char* serv_info[2] = {argv[2], argv[3]};
	// Connect to LCD
	if(pthread_create(&connect_lcd_t, NULL, connect_server, (void*)serv_info) < 0){
		perror("thread create error: ");
		exit(0);
    }

	pthread_join(wait_client_t, (void **)&status);
	pthread_join(connect_lcd_t, (void **)&status);


	pthread_t read_t;

	if(pthread_create(&read_t, NULL, read_person, NULL) < 0){
		perror("thread create error: ");
		exit(0);
    }

    while(1){
        sleep(1);
    }

    // while(1)
    // {
	// 	system("raspistil -o Image.JPG");
	// 	system("");

    //     if(pthread_create(&file_read_t, NULL, file_read, NULL) < 0){
    //         perror("thread create error: ");
    //         exit(0);
    //     }

    //     pthread_join(file_read_t, (void **)&status);

    //     if(pthread_create(&file_exec_t, NULL, file_exec, NULL) < 0){
    //         perror("thread create error: ");
    //         exit(0);
    //     }

    //     pthread_join(file_exec_t, (void **)&status);
    // }

    close(serv_sock);
    return 0;
}
